#pragma once

#include "HlslTextureOperation2d.h"
#include "ISimulationOperation.h"
#include "TechniqueOperation.h"
#include "TextureStore.h"

#pragma warning (disable:4995)
#include <memory>
#include <string>

class CalculateDensityChangesOperation2d : public ISimulationOperation
{
public:
    CalculateDensityChangesOperation2d(ID3D10Device* device, TextureStore* textureStore,
                                       int densityId, int densitySourcesId);
    ~CalculateDensityChangesOperation2d();

    void Run(float timestep, ID3D10Device* device);

private:
    void InitOperation(ID3D10Device* device);

    std::string effectName;

    TextureStore* textureStore;
    int densityId;
    int densitySourcesId;

    std::auto_ptr<TechniqueOperation> calculateDensitySourcesTechnique;
    std::auto_ptr<HlslTextureOperation> calculateDensitySourcesOperation;
};
