#pragma once

#include "HlslTextureOperation2d.h"
#include "ISimulationOperation.h"
#include "TechniqueOperation.h"
#include "TextureStore.h"

#pragma warning (disable:4995)
#include <memory>
#include <string>

class CalculateThermalExpansionOperation2d : public ISimulationOperation
{
public:
    CalculateThermalExpansionOperation2d(ID3D10Device* device, TextureStore* textureStore,
                                         int densitySourcesId, int thermalExpansionId);
    ~CalculateThermalExpansionOperation2d();

    void Run(float timestep, ID3D10Device* device);

private:
    void InitOperation(ID3D10Device* device);

    std::string effectName;

    TextureStore* textureStore;
    int densitySourcesId;
    int thermalExpansionId;

    std::auto_ptr<TechniqueOperation> calculateThermalExpansionTechnique;
    std::auto_ptr<HlslTextureOperation> calculateThermalExpansionOperation;
};
