#pragma once

#include "HlslTextureOperation2d.h"
#include "ISimulationOperation.h"
#include "TechniqueOperation.h"
#include "TextureStore.h"

#pragma warning (disable:4995)
#include <memory>
#include <string>

class CalculateVelocityForcesOperation2d : public ISimulationOperation
{
public:
    CalculateVelocityForcesOperation2d(ID3D10Device* device, TextureStore* textureStore,
                                       int velocityId, int velocityForcesId, int densityId);
    ~CalculateVelocityForcesOperation2d();

    void Run(float timestep, ID3D10Device* device);

private:
    void InitCalculateVorticityOperation(ID3D10Device* device);
    void InitCalculateVelocityForcesOperation(ID3D10Device* device);
    void InitMoveVortexParticlesOperation(ID3D10Device* device);
    void InitCalculateVortexParticleForcesOperation(ID3D10Device* device);

    void InitVortexParticleBuffers(ID3D10Device* device);

    std::string effectName;

    TextureStore* textureStore;
    int velocityId;
    int velocityForcesId;
    int densityId;
    int vorticityId;

    int vortexCount;

    auto_ptr<TechniqueOperation> calculateVorticityTechnique;
    auto_ptr<HlslTextureOperation> calculateVorticityOperation;

    auto_ptr<TechniqueOperation> calculateVelocityForcesTechnique;
    auto_ptr<HlslTextureOperation> calculateVelocityForcesOperation;

    auto_ptr<TechniqueOperation> moveVortexParticlesTechnique;

    auto_ptr<TechniqueOperation> calculateVortexParticleForcesTechnique;

    ID3D10Buffer* drawFromVortexBuffer;
    ID3D10Buffer* streamOutToVortexBuffer;
    ID3D10InputLayout* inputLayout;
};
