#pragma once
#include "ISimulationOperation.h"

#pragma warning (disable:4995)
#include <memory>
#include <string>

class TextureStore;
class TechniqueOperation;
class HlslTextureOperation;

using namespace std;

class ExplosionSpecificOperation3d : public ISimulationOperation
{
public:
    ExplosionSpecificOperation3d(ID3D10Device* device, TextureStore* textureStore,
                                int densityID, int velocityID, int thermalExpansionID, int obstaclesID);
    ~ExplosionSpecificOperation3d();

    void Run(float timestep, ID3D10Device* device);

private:
    void InitVorticityOperation(ID3D10Device* device);
    void InitExplosionSpecificOperation(ID3D10Device* device);
    void InitEffectVariables(ID3D10Device* device);

    string effectName;

    TextureStore* textureStore;
    int densityID;
    int velocityID;
    int thermalExpansionID;
    int vorticityID;
    int obstaclesID;

    auto_ptr<TechniqueOperation> calculateVorticityTechnique;
    auto_ptr<HlslTextureOperation> calculateVorticityOperation;

    auto_ptr<TechniqueOperation> explosionTechnique;
    auto_ptr<HlslTextureOperation> explosionOperation;

};
