#pragma once
#include "ISimulationOperation.h"
#include "DXUT.h"


#pragma warning (disable:4995)
#include <memory>
#include <string>

using namespace std;

class TechniqueOperation;
class TextureStore3D;

class VortexParticleOperation3d : public ISimulationOperation
{
public:
    VortexParticleOperation3d(ID3D10Device* device, TextureStore3D* textureStore, int velocityID);
    ~VortexParticleOperation3d();

    void Run(float timestep, ID3D10Device* device);

private:
    void InitVortexParticleBuffers(ID3D10Device* device);
    void InitMoveVorticesOperation(ID3D10Device* device);
    void InitRenderVorticesOperation(ID3D10Device* device);

    TextureStore3D* textureStore;
    int velocityID;

    ID3D10Buffer* drawFromVortexBuffer;
    ID3D10Buffer* streamOutToVortexBuffer;
    ID3D10InputLayout* inputLayout;

    auto_ptr<TechniqueOperation> moveParticlesTechnique;
    auto_ptr<TechniqueOperation> renderParticlesTechnique;


    int vortexCount;


    string effectName;
};
