#pragma once

#include "DXUT.h"

class BlackbodyRadiationManager
{
public:
	static const BlackbodyRadiationManager& Instance();

	const D3DXVECTOR4& GetColor(int level) const;
	const D3DXVECTOR4* GetAllColors() const;

private:
	BlackbodyRadiationManager();
	~BlackbodyRadiationManager();

	void Initialize();
	double Expose(double light, double exposure);
	double LightPower(double waveLength, double temperature);

private:
	static const double h;
	static const double c;
	static const double k;

	static const double redWave;
	static const double greenWave;
	static const double blueWave;

	static const double exposureLevel;

	D3DXVECTOR4 colors[256];
};
