#include "stdafx.h"

#include "ClearBuffersComponent.h"

ClearBuffersComponent::ClearBuffersComponent()
{
}

bool ClearBuffersComponent::LoadGeneralGraphicsContent(ID3D10Device* device, const DXGI_SURFACE_DESC* bufferSurfaceDesc)
{
	viewport.Width = bufferSurfaceDesc->Width;
    viewport.Height = bufferSurfaceDesc->Height;
    viewport.MinDepth = 0;
    viewport.MaxDepth = 1;
    viewport.TopLeftX = 0;
    viewport.TopLeftY = 0;

	return true;
}

void ClearBuffersComponent::Draw(ID3D10Device* device, double time, float elapsedTime)
{
	device->RSSetViewports( 1, &viewport );

	ID3D10RenderTargetView* RTV = DXUTGetD3D10RenderTargetView();
	ID3D10DepthStencilView* DSV = DXUTGetD3D10DepthStencilView();
	device->OMSetRenderTargets(1, &RTV, DSV);

	float ClearColor[4] = { 0.0f, 0.0f, 0.0f, 0.0f };
	device->ClearRenderTargetView( RTV, ClearColor );

	ID3D10DepthStencilView* pDSV = DXUTGetD3D10DepthStencilView();
	device->ClearDepthStencilView( pDSV, D3D10_CLEAR_DEPTH, 1.0, 0 );
}
