#pragma once

#include "DrawableGameComponent.h"
#include "ICameraProvider.h"
#include "ISimulationResultProvider.h"
#include "TechniqueOperation.h"

class ObstacleVisualizer : public DrawableGameComponent
{
public:
	ObstacleVisualizer(ISimulationResultProvider* simulationResultProvider, ICameraProvider* cameraProvider);
	~ObstacleVisualizer();

	bool LoadGeneralGraphicsContent(ID3D10Device* device, const DXGI_SURFACE_DESC *bufferSurfaceDesc);
	void ReleaseGeneralGraphicsContent();

	void Draw(ID3D10Device* device, double time, float elapsedTime);

private:
	bool InitBuffer(ID3D10Device* device);
	bool InitShader(ID3D10Device* device);

private:
	ISimulationResultProvider* simulationResultProvider;
	ICameraProvider* cameraProvider;

	ID3D10InputLayout* inputLayout;
	ID3D10Buffer* vertexBuffer;
	int vertexCount;

	TechniqueOperation* renderObstacleTechnique;
	ID3D10EffectMatrixVariable* worldMatrixVariable;
	ID3D10EffectMatrixVariable* viewMatrixVariable;
	ID3D10EffectMatrixVariable* projectionMatrixVariable;

	ID3D10ShaderResourceView* stoneWallTextureView;

	D3D10_VIEWPORT viewport;

	D3DXMATRIX world;
};
