#pragma once
#include "DXUT.h"

#pragma warning (disable:4995)
#include <string>

class TextureUtils
{
public:
	TextureUtils();
	~TextureUtils();

	static ID3D10Texture1D* CreateTexture1D(
		ID3D10Device* device, 
		int width,
		UINT bindFlags, 
		D3D10_USAGE usage = D3D10_USAGE_DEFAULT, 
		UINT cpuAccessFlags = 0);

	static ID3D10Texture1D* CreateTexture1D(
		ID3D10Device* device, 
		int width,
		const D3DXVECTOR4* initialData,
		UINT bindFlags, 
		D3D10_USAGE usage = D3D10_USAGE_DEFAULT, 
		UINT cpuAccessFlags = 0);

	static ID3D10Texture2D* CreateSimpleTexture2D(
		ID3D10Device* device, int width, int height, 
		UINT bindFlags, D3D10_USAGE usage = D3D10_USAGE_DEFAULT, UINT cpuAccessFlags = 0, DXGI_FORMAT format = DXGI_FORMAT_R32G32B32A32_FLOAT);

	static ID3D10Texture3D* CreateSimpleTexture3D(
		ID3D10Device* device, int width, int height, int depth, 
		UINT bindFlags, D3D10_USAGE usage = D3D10_USAGE_DEFAULT, UINT cpuAccessFlags = 0);


	static void SaveScreenShot(ID3D10Texture2D* source, ID3D10Texture2D* destination, std::string filename, ID3D10Device* device);
};
