#include "stdafx.h"

#include "VertexDefinition.h"

//--------------------------------------------------------------------------------------
// VertexPosition
//--------------------------------------------------------------------------------------


const D3D10_INPUT_ELEMENT_DESC VertexPosition::InputDesc[] = 
{
	{"POS", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D10_INPUT_PER_VERTEX_DATA, 0}
};

const int VertexPosition::InputElementCount = 1;


//--------------------------------------------------------------------------------------
// VertexPositionTexture
//--------------------------------------------------------------------------------------

const D3D10_INPUT_ELEMENT_DESC VertexPositionTexture::InputDesc[] = 
{
	{"POS", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D10_INPUT_PER_VERTEX_DATA, 0},
	{"TEXCOORD", 0, DXGI_FORMAT_R32G32_FLOAT, 0, 12, D3D10_INPUT_PER_VERTEX_DATA, 0}
};

const int VertexPositionTexture::InputElementCount = 2;


//--------------------------------------------------------------------------------------
// VertexPositionTextureOffset
//--------------------------------------------------------------------------------------

const D3D10_INPUT_ELEMENT_DESC VertexPositionTextureOffset::InputDesc[] = 
{
	{"POS", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D10_INPUT_PER_VERTEX_DATA, 0},
	{"TEXCOORD", 0, DXGI_FORMAT_R32G32_FLOAT, 0, 12, D3D10_INPUT_PER_VERTEX_DATA, 0},
	{"OFFSET", 0, DXGI_FORMAT_R32G32_FLOAT, 0, 20, D3D10_INPUT_PER_VERTEX_DATA, 0}
};

const int VertexPositionTextureOffset::InputElementCount = 3;


//--------------------------------------------------------------------------------------
// VertexPositionRadiusStrength
//--------------------------------------------------------------------------------------

const D3D10_INPUT_ELEMENT_DESC VertexPositionRadiusStrength::InputDesc[] = 
{
	{"POS", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D10_INPUT_PER_VERTEX_DATA, 0},
	{"RADIUS", 0, DXGI_FORMAT_R32_FLOAT, 0, 12, D3D10_INPUT_PER_VERTEX_DATA, 0},
	{"STRENGTH", 0, DXGI_FORMAT_R32_FLOAT, 0, 16, D3D10_INPUT_PER_VERTEX_DATA, 0}
};

const int VertexPositionRadiusStrength::InputElementCount = 3;


//--------------------------------------------------------------------------------------
// VertexPositionVelocityRMass
//--------------------------------------------------------------------------------------

const D3D10_INPUT_ELEMENT_DESC VertexPositionVelocityRMass::InputDesc[] = 
{
	{"POS",      0, DXGI_FORMAT_R32G32B32_FLOAT,  0, 0,  D3D10_INPUT_PER_VERTEX_DATA, 0},
	{"VELOCITY", 0, DXGI_FORMAT_R32G32B32_FLOAT,  0, 12, D3D10_INPUT_PER_VERTEX_DATA, 0},
	{"RMASS",    0, DXGI_FORMAT_R32_FLOAT,        0, 24, D3D10_INPUT_PER_VERTEX_DATA, 0}
};

const int VertexPositionVelocityRMass::InputElementCount = 3;


//--------------------------------------------------------------------------------------
// VertexPositionRMassType
//--------------------------------------------------------------------------------------

const D3D10_INPUT_ELEMENT_DESC VertexPositionRMassType::InputDesc[] = 
{
	{"POS",      0, DXGI_FORMAT_R32G32B32_FLOAT,  0, 0,  D3D10_INPUT_PER_VERTEX_DATA, 0},
	{"RMASS",    0, DXGI_FORMAT_R32_FLOAT,        0, 12, D3D10_INPUT_PER_VERTEX_DATA, 0},
    {"TYPE",     0, DXGI_FORMAT_R8_UINT,          0, 16, D3D10_INPUT_PER_VERTEX_DATA, 0}
};

const int VertexPositionRMassType::InputElementCount = 3;

//--------------------------------------------------------------------------------------
// VertexPositionTexture3D
//--------------------------------------------------------------------------------------

const D3D10_INPUT_ELEMENT_DESC VertexPositionTexture3D::InputDesc[] = 
{
	{"POS",			0, DXGI_FORMAT_R32G32B32_FLOAT,  0, 0,  D3D10_INPUT_PER_VERTEX_DATA, 0},
	{"TEXCOORD",    0, DXGI_FORMAT_R32G32B32_FLOAT,  0, 12, D3D10_INPUT_PER_VERTEX_DATA, 0},
};

const int VertexPositionTexture3D::InputElementCount = 2;

