#pragma once

#include "DXUT.h"

class VertexPosition 
{
private:
	D3DXVECTOR3 Position;
public:
	VertexPosition() : Position(0,0,0) {}
	VertexPosition(D3DXVECTOR3 Pos) : Position(Pos) {}
	
	static const D3D10_INPUT_ELEMENT_DESC InputDesc[];
	static const int InputElementCount;

};

class VertexPositionTexture
{
private:
	D3DXVECTOR3 Position;
	D3DXVECTOR2 TexCoord;
public:
	VertexPositionTexture() : Position(0,0,0), TexCoord(0,0) {}
	VertexPositionTexture(D3DXVECTOR3 Pos, D3DXVECTOR2 Tex) : Position(Pos), TexCoord(Tex) {}

	static const D3D10_INPUT_ELEMENT_DESC InputDesc[];
	static const int InputElementCount;
};

class VertexPositionTextureOffset
{
private:
	D3DXVECTOR3 Position;
	D3DXVECTOR2 TexCoord;
	D3DXVECTOR2 Offset;
public:

	VertexPositionTextureOffset(D3DXVECTOR3 Pos, D3DXVECTOR2 Tex, D3DXVECTOR2 Offset) 
		: Position(Pos), TexCoord(Tex), Offset(Offset) {}

	static const D3D10_INPUT_ELEMENT_DESC InputDesc[];
	static const int InputElementCount;
};

class VertexPositionRadiusStrength
{
private:
	D3DXVECTOR3 Position;
	FLOAT Radius; 
	FLOAT Strength; 
public:
	VertexPositionRadiusStrength()
		: Position(0,0,0), Radius(0), Strength(0) {}
	VertexPositionRadiusStrength(D3DXVECTOR3 Pos, FLOAT Radius, FLOAT Strength)
		: Position(Pos), Radius(Radius), Strength(Strength) {}

	static const D3D10_INPUT_ELEMENT_DESC InputDesc[];
	static const int InputElementCount;
};
	
class VertexPositionVelocityRMass
{
private:
	D3DXVECTOR3 Position;
	D3DXVECTOR3 Velocity;
	FLOAT RMass; 
public:
	VertexPositionVelocityRMass()
		: Position(0,0,0), Velocity(0,0,0), RMass(0) {}
	VertexPositionVelocityRMass(D3DXVECTOR3 Pos, D3DXVECTOR3 Velocity, FLOAT RMass)
		: Position(Pos), Velocity(Velocity), RMass(RMass) {}

	static const D3D10_INPUT_ELEMENT_DESC InputDesc[];
	static const int InputElementCount;
};


class VertexPositionRMassType
{
private:
	D3DXVECTOR3 Position;
	FLOAT RMass; 
	unsigned char Type;
public:
	VertexPositionRMassType()
		: Position(0,0,0), RMass(0), Type(0) {}
	VertexPositionRMassType(D3DXVECTOR3 Pos, FLOAT RMass, unsigned char type)
		: Position(Pos), RMass(RMass), Type(type) {}

	static const D3D10_INPUT_ELEMENT_DESC InputDesc[];
	static const int InputElementCount;
};

class VertexPositionTexture3D
{
private:
	D3DXVECTOR3 Position;
	D3DXVECTOR3 TexCoord;
public:
	VertexPositionTexture3D()
		: Position(0,0,0), TexCoord(0,0,0) {}
	VertexPositionTexture3D(D3DXVECTOR3 Pos, D3DXVECTOR3 TexCoord)
		: Position(Pos), TexCoord(TexCoord) {}

	static const D3D10_INPUT_ELEMENT_DESC InputDesc[];
	static const int InputElementCount;
};
