#include "stdafx.h"

#include "CameraComponent.h"

CameraComponent::CameraComponent()
{
	camera = new CFirstPersonCamera();

	// Initialize the camera
	D3DXVECTOR3 eye( 4.0f, -2.75f, -12.0f );
	D3DXVECTOR3 lookAt( 4.0f, -2.75f, 0.0f );
	//D3DXVECTOR3 eye( 1.0f, 1.0f, -5.0f );
	//D3DXVECTOR3 lookAt( 1.0f, 1.0f, 0.0f );
	camera->SetViewParams( &eye, &lookAt );
}

CameraComponent::~CameraComponent()
{
	SAFE_DELETE(camera);
}

bool CameraComponent::HandleMessage( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	this->camera->HandleMessages(hWnd, uMsg, wParam, lParam);
	return true;
}

void CameraComponent::Update( double time, float elapsedTime )
{
	this->camera->FrameMove(elapsedTime);
}

const CBaseCamera& CameraComponent::GetCamera()
{
	return *(this->camera);
}

void CameraComponent::LoadBackBufferDependantGraphicsContent( ID3D10Device* d3dDevice, IDXGISwapChain *swapChain, const DXGI_SURFACE_DESC* bufferSurfaceDesc )
{
	float fAspectRatio = static_cast<float>(bufferSurfaceDesc->Width) / static_cast<float>(bufferSurfaceDesc->Height);
	this->camera->SetProjParams( D3DX_PI/4, fAspectRatio, 0.1f, 5000.0f );
}

void CameraComponent::CleanUp()
{
	DrawableGameComponent::CleanUp();
}
