#pragma once
#include "DXUT.h"
#include "DXUTcamera.h"
#include "DrawableGameComponent.h"
#include "MessageHandler.h"
#include "ICameraProvider.h"


class CameraComponent : public MessageHandler, public DrawableGameComponent, public ICameraProvider
{
public:
	CameraComponent();
	~CameraComponent();

	bool HandleMessage(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	virtual void Update(double time, float elapsedTime);
	virtual void LoadBackBufferDependantGraphicsContent(ID3D10Device* d3dDevice, IDXGISwapChain *swapChain, const DXGI_SURFACE_DESC* bufferSurfaceDesc);

	const CBaseCamera& GetCamera();

	void CleanUp();
private:
	CFirstPersonCamera *camera;
};
