// SimpleFFTWWrapper.h

#pragma once

#include "fftw3.h"

using namespace System;

namespace SimpleFFTWWrapper {

	public enum class FFTTransformType
	{
		//FORWARD,
		BACKWARD
	};

	public ref class FFTWComplex2D
	{
	public:
		FFTWComplex2D(int nx, int ny, FFTTransformType type);
		~FFTWComplex2D();
		!FFTWComplex2D();

		void transform();
		void zero();

		void setInput(int x, int y, double real, double imag);
		double getRealInput(int x, int y);
		double getImagInput(int x, int y);

		double getRealOutput(int x, int y);
		double getImagOutput(int x, int y);

		property int Nx
		{
			int get() 
			{
				return nx;
			}
		}

		property int Ny
		{
			int get() 
			{
				return ny;
			}
		}

	private:
		int nx, ny;
		fftw_complex *in, *out;
	};

	public ref class FFTWComplex3D
	{
	public:
		FFTWComplex3D(int nx, int ny, int nz, FFTTransformType type);
		~FFTWComplex3D();
		!FFTWComplex3D();

		void transform();
		void zero();

		void setInput(int x, int y, int z, double real, double imag);
		double getRealInput(int x, int y, int z);
		double getImagInput(int x, int y, int z);

		double getRealOutput(int x, int y, int z);
		double getImagOutput(int x, int y, int z);

		property int Nx
		{
			int get() 
			{
				return nx;
			}
		}

		property int Ny
		{
			int get() 
			{
				return ny;
			}
		}

		property int Nz
		{
			int get() 
			{
				return nz;
			}
		}

	private:
		int nx, ny, nz;
		fftw_complex *in, *out;
	};

}
